package com.archeus;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * <p>
 * Lista de <code>FormatedWord</code> avand o eticheta(<code>name</code>)
 * </p>
 * 
 * @author ionut
 * @since Feb 25, 2007 10:29:32 AM
 */
public class WordList {

	public static final class Type {
		public static final String HEAD = "head";

		public static final String FEMININE = "feminin";

		public static final String PLURAL_GROUP = "grup plural";

		public static final String PLURAL = "plural";

		public static final String PLURAL_COMMENT = "comentariu plural";

		public static final String POS = "pos";

		public static final String SENSES = "sensuri";

		public static final String SENSE = "sens"; // numar sens

		public static final String DEFINITION = "definitie";

		public static final String DEFINITION_COMMENT = "comentariu definitie";

		public static final String PROVENANCE = "provenienta";
	}

	private String name;

	private String type;

	private WordListArray pos = new WordListArray();

	private FormatedWordList list = new FormatedWordList();

	private FormatedWordList exp = new FormatedWordList();

	private WordListArray children = new WordListArray();

	// private int level;

	// /**
	// * <p>Nivel - se aplica doar la sensuri</p>
	// * @author ionut
	// * @since Feb 25, 2007 11:19:32 PM
	// * @return
	// */
	// public int getLevel() {
	// return level;
	// }
	// public void setLevel(int level) {
	// this.level = level;
	// }
	public WordList(String type) {
		super();
		this.type = type;
		this.name = type;
	}

	public FormatedWordList getList() {
		return list;
	}

	public void setList(FormatedWordList list) {
		this.list = list;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public WordListArray getChildren() {
		return children;
	}

	public void setChildren(WordListArray childs) {
		this.children = childs;
	}

	public void saveXML(Document doc, Element dest) {
		Element e = doc.createElementNS(null, "item");
		e.setAttributeNS(null, "type", type);
		e.setAttributeNS(null, "name", name);
		// Node n = doc.createTextNode("");
		// e.appendChild(n);
		dest.appendChild(e);

		if (pos.size() != 0) {
			Element l = doc.createElementNS(null, "pos");
			for (WordList w : pos)
				w.saveXML(doc, l);
			e.appendChild(l);
		}// if
		if (list.size() != 0) {
			Element l = doc.createElementNS(null, "words");
			for (FormatedWord w : list)
				w.saveXML(doc, l);
			e.appendChild(l);
		}// if
		if (exp.size() != 0) {
			Element l = doc.createElementNS(null, "exp");
			for (FormatedWord w : exp)
				w.saveXML(doc, l);
			e.appendChild(l);
		}// if
		if (children.size() != 0) {
			Element l = doc.createElementNS(null, "children");
			for (WordList w : children)
				w.saveXML(doc, l);
			e.appendChild(l);
		}// if
	}

	public String asString(boolean exp, boolean prov) {
		if ((type == Type.PROVENANCE) && !prov)
			return "";
		StringBuffer b = new StringBuffer();
		if ((type == Type.SENSE) &&!getName().equals(Type.SENSE))
			b.append(getName() + ". ");

		for (WordList w : pos)
			b.append(w.asString(exp, prov));
		for (FormatedWord w : list)
			b.append(w.asString());
		if (exp)
			for (FormatedWord w : this.exp)
				b.append(w.asString());
		for (WordList w : children)
			b.append(w.asString(exp, prov));
		return b.toString();
	}

	public WordListArray getPos() {
		return pos;
	}

	public FormatedWordList getExp() {
		return exp;
	}
}
