package com.archeus;

import java.io.StringWriter;
import java.util.ArrayList;

import org.apache.xerces.dom.DocumentImpl;
import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class WordListArray extends ArrayList<WordList> {
	private static final long serialVersionUID = 1L;

	public String saveXML() throws Exception{
		Document xmldoc = new DocumentImpl();
		Element root = xmldoc.createElement("definition");
		for (WordList w : this) 
			w.saveXML(xmldoc, root);
		xmldoc.appendChild(root);
//		FileOutputStream fos = new FileOutputStream("");
		StringWriter w = new StringWriter(1024*10);
		// XERCES 1 or 2 additionnal classes.
		OutputFormat of = new OutputFormat("XML", "UTF-8", true);
		of.setIndent(1);
		of.setIndenting(true);
//		of.setDoctype(null, "users.dtd");
		XMLSerializer serializer = new XMLSerializer(w, of);
		// As a DOM Serializer
		serializer.asDOMSerializer();
		serializer.serialize(xmldoc.getDocumentElement());
//		fos.close();
		return w.toString();
	}

	public String asString(boolean exp, boolean prov) {
		StringBuffer buff = new StringBuffer(1024 * 5);
		for (WordList w : this) {
			buff.append(w.asString(exp, prov));
		}
		return buff.toString();
	}

}
