package com.archeus.dex.xml.test;

import com.archeus.WordList;

public class TestDexToXMLMure extends TestDexToXMLGeneric {

	public static String fileName = "C:\\Cache\\java\\WorkspaceTraducator\\DEXToXML\\data\\mure.html";

	public void testHead() throws Exception{
		loadFile(fileName);
		if (res.size() < 1)
			fail("size<1");
		WordList w = res.get(0);
		assertEquals(w.getName(), WordList.Type.HEAD);
		assertEquals(w.getList().toString(), "MURA^3,"); 
		assertEquals(w.getList().size(), 2);
//		System.out.println(res.size());
//		System.out.println(res.saveXML());
	}

	public void testPluralPOS() {
		loadFile(fileName);
		if (res.size() < 2)
			fail("size<2");
		WordList w = res.get(1);
		assertEquals(w.getName(), WordList.Type.PLURAL_GROUP);
		assertEquals(w.getChildren().size(), 2);
		assertEquals(w.getChildren().get(0).getList().toString(), "mure, ");
		assertEquals(w.getChildren().get(1).getList().toString(), " s.f. ");
	}
	
	
	public void testSens() {
		loadFile(fileName);
		if (res.size() < 3)
			fail("size<3: " + res.size());
		WordList w = res.get(2);
		assertEquals(w.getType(), WordList.Type.SENSES);
		assertEquals(w.getName(), WordList.Type.SENSES);
		assertEquals(w.getList().toString(), "");
		if (w.getChildren().size() != 1)
			fail("nr sensuri != 1: " + w.getChildren().size());
		WordList sens;
		// 1
		sens = w.getChildren().get(0);
		assertEquals(sens.getType(), WordList.Type.SENSE);
		assertEquals(sens.getName(), "sens");
		assertTrue(sens.getList().size()> 0);
		assertEquals(sens.getList().get(0).getText(), "Parâma");
		
	}

	public void testProvenienta() {
		loadFile(fileName);
		if (res.size() < 4)
			fail("size<4: " + res.size());
		WordList w = res.get(3);
		assertEquals(w.getType(), WordList.Type.PROVENANCE);
		assertTrue(w.getList().toString().startsWith("- Din it. mura"));
	}
	
}
